MDL-29996 remove legacy_filter support
[moodle.git] / mod / upgrade.txt
CommitLineData
9c82ff2a 1This files describes API changes in /mod/* - activity modules,
2information provided here is intended especially for developers.
3
9c82ff2a 4
7d59d8da
PS
5=== 2.4 ===
6
7new features:
8
9* mod/xxx/adminlib.php may now include 'plugininfo_yoursubplugintype' class definition
10 used by plugin_manager; it is recommended to store extra admin settings classes in this file
76fb0443 11
27affa26
AA
12optional - no changes needed:
13
14* mod_lesson_renderer::header() now accepts an additional parameter $extrapagetitle
7d59d8da 15
76fb0443
AG
16* mod/data/lib.php data_get_all_recordids() now has two new optional variables: $selectdata and $params.
17
0f0c0228
TH
18=== 2.3 ===
19
20required changes in code:
daefd6eb 21
0f0c0228
TH
22* define the capability mod/xxx:addinstance (and the corresponding lang string)
23 (unless your mod is a MOD_ARCHETYPE_SYSTEM).
261cbbac
DM
24* xxx_pluginfile() is now given the 7th parameter (hopefully the last one) that
25 contains additional options for the file serving. The array should be re-passed
26 to send_stored_file().
0f0c0228 27
daefd6eb 28* most resourcelib_embed_* functions are replaced with core_media_renderer;
29 for an example, see mod/resource/locallib.php, resource_display_embed()
30
652cc648
DS
31optional - no changes needed:
32
33* add support for handling course drag and drop types - functions
34 xxx_dndupload_register() and xxx_dndupload_handle($uploadinfo) see:
35 http://docs.moodle.org/dev/Implementing_Course_drag_and_drop_upload_support_in_a_module
0f0c0228 36
ee362526
PS
37=== 2.2 ===
38
39required changes in code:
40* fix missing parameter types in optional_param() and required_param()
41* use new optional_param_array(), required_param_array() or clean_param_array() when dealing with array parameters
42* textlib->asort() replaced by specialized collatorlib::asort()
43* use new make_temp_directory() and make_cache_directory()
44
45
46=== 2.1 ===
47
48required changes in code:
49* add new support for basic restore from 1.9
50
51
52=== 2.0 ===
44f2977c 53
9c82ff2a 54required changes in code:
55* use new DML syntax everywhere
728ebac7 56 (http://docs.moodle.org/dev/DML_functions)
9c82ff2a 57* use new DDL syntax in db/upgrade.php
728ebac7 58 (http://docs.moodle.org/dev/DDL_functions)
9c82ff2a 59* replace defaults.php by settings.php and db/install.php
847400a7 60* replace STATEMENTS section in db/install.xml with PHP code db/install.php or db/log.php
9cb56578 61* move post installation code from lib.php into db/install.php
56f7ff74 62* move uninstallation code from lib.php to db/uninstall.php
8026a943
PS
63* new mandatory naming of intro and introformat table fields in module tables,
64 the presence of these fields is indicated in xxx_plugin_supports()
9c82ff2a 65* completely rewrite file handling
728ebac7 66 (http://docs.moodle.org/dev/File_API)
9c82ff2a 67* rewrite backup/restore
44f2977c 68 (not finished yet)
9cb56578
PS
69* rewrite trusttext support - new db table columns needed
70* migrate all module features from mod_edit.php form to lib.php/modulename_supports() function
398a160d 71* implement new gradebook support (legacy 1.8.x grading not supported anymore)
44f2977c
PS
72* migrate custom resource module subtypes into separate modules,
73 necessary only for custom plugins in mod/resource/
af34490a 74* use new $PAGE and $OUTPUT instead of old weblib functions
78946b9b
PS
75* theme changes: move plugin styles into mod/xxx/styles.css and use new css markers for images,
76 move all images into new mod/xxx/pix/ directory and use new outputlib api
77 move module icon to mod/xxx/pix/icon.gif
cbcc9852 78 old global $THEME is fully replaced by $OUTPUT
8026a943 79 create plugin renderers
728ebac7 80 (http://docs.moodle.org/dev/Theme_changes_in_2.0)
b7534190 81* migrate all javascript new coding style using YUI3+YUI2
728ebac7 82 (http://docs.moodle.org/dev/JavaScript_usage_guide)
2b0e098e
PS
83* remove '_utf8' from lang pack names, use new {a} syntax
84* replace helps with new 'xxx_hlp' strings
7070ca36 85* please note the $plugin->requires in version.php has to be bigger than 2010000000,
dae88219 86 otherwise the plugin is marked as outdated and upgrade is interrupted
9c82ff2a 87
88optional - no changes needed in older code:
dbf9e4ba 89* settingstree.php replaced by settings.php - just unset the $settings if you want to make custom part of settings admin tree
ff3ad2d9
PS
90* support for new mforms editor element and embedded files
91 (not finished yet)
9c82ff2a 92* portfolio support
728ebac7 93 (http://docs.moodle.org/dev/Portfolio_API)
9c82ff2a 94* course completion tracking support
8026a943
PS
95* new navigation features
96* new comments API
728ebac7 97 (http://docs.moodle.org/dev/Comments_2.0)
8026a943 98* new ratings API
728ebac7 99 (http://docs.moodle.org/dev/Ratings_2.0)
9c82ff2a 100